<a id="mypy-boto3-sso"></a>

# mypy-boto3-sso

[![PyPI - types-aiobotocore-sso](https://img.shields.io/pypi/v/types-aiobotocore-sso.svg?color=blue)](https://pypi.org/project/types-aiobotocore-sso)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-sso.svg?color=blue)](https://pypi.org/project/types-aiobotocore-sso)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-sso?color=blue)](https://pypistats.org/packages/types-aiobotocore-sso)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.SSO 1.20.47](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/sso.html#SSO)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[types-aiobotocore-sso docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_sso/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-sso](#mypy-boto3-sso)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `SSO`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `SSO` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[sso]'

# Lite version does not provide session.create_client overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[sso]'

# standalone installation
python -m pip install types-aiobotocore-sso
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[sso]` in your environment:
  `python -m pip install 'types-aiobotocore[sso]'`

Both type checking and auto-complete should work for `SSO` service. No explicit
type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `types-aiobotocore[sso]` in your environment:
  `python -m pip install 'types-aiobotocore[sso]'`

Both type checking and auto-complete should work for `SSO` service. No explicit
type annotations required, write your `aiobotocore` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`types-aiobotocore` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[sso]` in your environment:
  `python -m pip install 'types-aiobotocore[sso]'`
- Run `mypy` as usual

Type checking should work for `SSO` service. No explicit type annotations
required, write your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `types-aiobotocore[sso]` in your environment:
  `python -m pip install 'types-aiobotocore[sso]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `SSO` service. No explicit type annotations
required, write your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`SSOClient` provides annotations for `session.create_client("sso")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_sso import SSOClient

session = get_session()
async with session.create_client("sso") as client:
    client: SSOClient
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_sso.paginator` module contains type annotations for all
paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_sso import SSOClient
from types_aiobotocore_sso.paginator import (
    ListAccountRolesPaginator,
    ListAccountsPaginator,
)

session = get_session()
async with session.create_client("sso") as client:
    client: SSOClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        list_account_roles_paginator: ListAccountRolesPaginator = client.get_paginator("list_account_roles")
        list_accounts_paginator: ListAccountsPaginator = client.get_paginator("list_accounts")
    ```







### Literals

`types_aiobotocore_sso.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_sso.literals import (
    ListAccountRolesPaginatorName,
    ListAccountsPaginatorName,
    ServiceName,
    PaginatorName,
)

def check_value(value: ListAccountRolesPaginatorName) -> bool:
    ...
````

### Typed dictionaries

`types_aiobotocore_sso.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_sso.type_defs import (
    AccountInfoTypeDef,
    GetRoleCredentialsRequestRequestTypeDef,
    GetRoleCredentialsResponseTypeDef,
    ListAccountRolesRequestRequestTypeDef,
    ListAccountRolesResponseTypeDef,
    ListAccountsRequestRequestTypeDef,
    ListAccountsResponseTypeDef,
    LogoutRequestRequestTypeDef,
    PaginatorConfigTypeDef,
    ResponseMetadataTypeDef,
    RoleCredentialsTypeDef,
    RoleInfoTypeDef,
)

def get_structure() -> AccountInfoTypeDef:
    return {
      ...
    }
```

## Versioning

`types-aiobotocore-sso` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

## Documentation

All type annotations can be found in
[types-aiobotocore-sso docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_sso/)

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
